;  This file will translate Function key sequences into those expected by
;  MicroEMACS Version 3.12.  Note that termcap entry definitions will take
;  precedence over this but does not cover all keys.
;
;  Expected character sequence is ^[Ox or ^[[y
;    where the ^[O is bound to the procedure key-handler-1
;    and ^[[ to key-handler-2
;          the x and y are actually codes that identify the actual key
;            (the strings below give the code/key mappings)
; Modifie 22/09/92 E.Picheral => touche HOME
; 	  13/08/93 E.Picheral => adaptation claviers Sun et NCD

set %olddiscmd $discmd
set $discmd "FALSE"

;                        Note: function key 0 is FN10
;-----------------------------
; handler des sequences escO[p-y]~ des touches Shift-Ri
; (claviers Sun4)
;
set %fkin  "pqrstuvwxy"  ; => S-FN0 ... S-FN9
set %fkout "0123456789"

store-procedure key-handler-1
;set $debug "TRUE"
    set %olddiscmd $discmd
    set $discmd "TRUE"
    set %oldmode $cmode
;;  add-mode "EXACT"  -- BAD! causes the cursor to move and mode line updated
    set $cmode &bor $cmode 8
    set %key &gtkey	; get lead-in character

    set %keyx &sindex %fkin %key
    !if %keyx
        set %key &cat "S-FN" &mid %fkout %keyx 1
	!goto done1
    !endif
; caractere inconnu
*quit1
	write-message &cat &cat "[Touche fonction inconnue : ~"escO" %key "~" ]"
	insert-string &chr 27
	insert-string "O"
	insert-string %key
	set $cmode %oldmode
	set $discmd %olddiscmd
	!return
;
*done1
	done-handler
!endm
;-----------------------------
; handler des sequences esc[[1,2][0-9]~ des touches Fi
;                    et esc[[AABCDHUV] des flches, HOME, PgDn, PgUp
; (claviers Sun4)
;
set %akin1  "12345789"	; F1 F2 F3 F4 F5 F6 F7 F8
set %akout1 "12345678"	; FN 1-8
set %akin2  "01"	; F9 F10
set %akout2 "90"	; FN9 FN0
set %akinF  "ABCDHUV"	; ^   v   >   <   Home PgDn PgUp
set %akoutF "PNFB<VZ"	; FNP FNN FNF FNB FN<  FNV  FNZ
;
store-procedure key-handler-2
    set %olddiscmd $discmd
    set $discmd "TRUE"
    set %oldmode $cmode
;;  add-mode "EXACT"  -- BAD! causes the cursor to move and mode line updated
    set $cmode &bor $cmode 8
	set %fleche FALSE
	set %key2 ""
	set %key1 &gtkey	; get lead-in character

	!if &sequal %key1 "1"
		set %key2 &gtkey
		set %keyx &sindex %akin1 %key2
		!if %keyx
			set %key &cat "FN" &mid %akout1 %keyx 1
		        !goto done2
		!endif
		!goto quit2
	!endif
	!if &sequal %key1 "2"
		set %key2 &gtkey
		set %keyx &sindex %akin2 %key2 
		!if %keyx
			set %key &cat "FN" &mid %akout2 %keyx 1
			!goto done2
		!endif
		!goto quit2
	!endif
	set %keyx &sindex %akinF %key1
	!if %keyx
		set %key &cat "FN" &mid %akoutF %keyx 1
		set %fleche TRUE
		!goto done2
	!endif
*quit2
	write-message &cat &cat &cat "[Touche fonction inconnue : ~"esc[" %key1 %key2 "~" ]"
	insert-string &chr 27
	insert-string "["
	insert-string %key1
	insert-string %key2
	set $cmode %oldmode
	set $discmd %olddiscmd
	!return
*done2
	!if &seq %fleche FALSE
		set %lastkey &gtkey
		!if &not &sequal %lastkey "~~"	; VT220 Function keys code end with ~
			set %key2 &cat %key2 %lastkey
			!goto quit2
		!endif
	!endif
	done-handler
!endm
;-----------------------------
; done-handler - %key contient le nom symbolique de la touche
;
store-procedure done-handler
    set $cmode %oldmode
    set %func &bind %key
    !if &sequal %func "ERROR"
        !if &sequal $version 3.12
            write-message &cat &cat "[Touche fonction non lie : ~"" %key "~" ]"
	!else
            write-message &cat &cat "[Touche fonction non liee : ~"" %key "~" ]"
	!endif
    !else
        !if &sequal &left %func 1 "["  ; procedures are in brackets
            set %func &mid %func 2 &sub &length %func 2
            !force execute-procedure %func ; user procedure
        !else
            !force execute-named-command %func ; try for built-in
        !endif
    !endif
    set $discmd %olddiscmd
!endm
;----------------------------
macro-to-key key-handler-1 M-O	; touches pave numerique (Rx) sauf flches
macro-to-key key-handler-2 M-[	; touches Fi Lj et flches
set $discmd %olddiscmd
