;  fman.cmd:	Procedures pour saisie de texte francais pour des "man"
;		traitement des lettres accentuees, du c cedille, des
;		ligatures oe et OE et de l'espace force avant : ; ! ?
;		et des guillemets francais
;		Version Unix
;		Auteur : Eric Picheral au CICB <picheral@cicb.cicb.fr>
;		15 fevrier 1991
; Ne fonctionne qu'avec MicroEMACS 3.10 modifie par JP. Routeau
;
; Modifications :
; E.Picheral 19/04/95: suppression appel execute-macro-20

set $discmd FALSE

; ------------------ {eE} apostrophe
store-procedure maigu
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "'"
	!return
    !endif
    backward-character
    !if &or &sequal &chr $curchar e &sequal &chr $curchar E
	insert-string &cat &chr $curchar "\*'"
	delete-next-character
    !else
	forward-character
	insert-string "'"
    !endif
!endm

; ------------------ {aeuAEU} accent grave
store-procedure mgrave
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "`"
	!return
    !endif
    backward-character
    !if &greater &sindex "aeuAEU" &chr $curchar 0
	insert-string &cat &chr $curchar "\*`"
	delete-next-character
    !else
	forward-character
	insert-string "`"
    !endif
!endm

; ------------------ {aeiouAEIOU} chapeau
store-procedure mcirc
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "^"
	!return
    !endif
    backward-character
    !if &greater &sindex "aeouAEIOU" &chr $curchar 0
	insert-string &cat &chr $curchar "\*^"
	delete-next-character
    !else
	!if &sequal &chr $curchar i
	    forward-character
	    insert-string "\*^"
	!else
	    forward-character
	    insert-string "^"
	!endif
    !endif
!endm

; ------------------ {cC} tilda
store-procedure mcedille
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "~~"
	!return
    !endif
    backward-character
    !if &or &sequal &chr $curchar c &sequal &chr $curchar C
	insert-string &cat &chr $curchar "\*,"
	delete-next-character
    !else
	forward-character
	insert-string "~~"
    !endif
!endm

; ------------------ {eiuEIU} dieze
store-procedure mtrema
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "#"
	!return
    !endif
    backward-character
    !if &greater &sindex "euEIU" &chr $curchar 0
	insert-string &cat &chr $curchar "\*:"
	delete-next-character
    !else
        !if &sequal &chr $curchar i
	    forward-character
	    insert-string "\*:"
	!else
	    forward-character
	    insert-string "#"
	!endif
    !endif
!endm

; ---------------------- ligature optionnelle oe
store-procedure mligat-oe
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string &chr $lastkey
	!return
    !endif
    backward-character
    !if &sequal &chr $curchar o
	print ""
	set %fligat @"ligature oe ? (o/n, [o])"
	!if &or &sequal %fligat "o" &or &sequal %fligat "y" &equal &length %fligat 0
	    insert-string "\*oe"
	    delete-next-character
	!else
	    forward-character
	    insert-string "e"
	!endif
    !else
	forward-character
	insert-string "e"
    !endif
!endm

; ---------------------- ligature optionnelle OE
store-procedure mligat-OE
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string &chr $lastkey
	!return
    !endif
    backward-character
    !if &sequal &chr $curchar O
	print ""
	set %fligat @"ligature OE ? (o/n, [o])"
	!if &or &sequal %fligat "o"  &or &sequal %fligat "y"&equal &length %fligat 0
	    insert-string "\*Oe"
	    delete-next-character
	!else
	    forward-character
	    insert-string "E"
	!endif
    !else
	forward-character
	insert-string "E"
    !endif
!endm

; ----------------------- insertion espace insecable avant : ; ! ?
store-procedure mdbl-ponct
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string &chr $lastkey
	!return
    !endif
    backward-character
    !while &or &equal $curchar 32 &sequal &chr $curchar "~t"
	delete-next-character
	backward-character
    !endwhile
    !if &not &sequal &chr $curchar "\ "
	forward-character
	insert-string "\ "
    !else
	forward-character
    !endif
    insert-string &chr $lastkey
!endm


; ------------------------- \documentstyle \begin{document} \end{document}
store-procedure en-tete
	open-line
	beginning-of-file
;	set %style @"style de document ?"
!endm


; ------------------------ execution  man sur buffer courant
store-procedure man-buffer
!endm

; ----------------------- activation pilote PS et impression
store-procedure man-print
!endm

; ----------------------- affichage file d'attente imprimante
store-procedure man-queue
; acrobatie a cause de l'absence de $windowhook ...
    set $readhook nop
    pipe-command "lpq"
    set $readhook set-default-mode
    add-mode "view"
    name-buffer "file d'attente"
    end-of-file
    !if &less $curline $wline
	&sub $curline 1 resize-window
    !endif
    beginning-of-file
!endm

; -------------------- << guillemets francais ouvrants
store-procedure moguill
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "<"
	!return
    !endif
    backward-character
    !if &sequal &chr $curchar <
	insert-string "\(d<"
	delete-next-character
    !else
	forward-character
	insert-string "<"
    !endif
!endm

; -------------------- >> guillemets francais fermants
store-procedure mfguill
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string ">"
	!return
    !endif
    backward-character
    !if  &sequal &chr $curchar >
	insert-string "\(d>"
	delete-next-character
    !else
	forward-character
	insert-string ">"
    !endif
!endm

; --------------------------- activation mode man
store-procedure set-fman-mode
    set $discmd FALSE
    macro-to-key maigu      "'"
    macro-to-key mgrave     "`"
    macro-to-key mcirc      "^"
    macro-to-key mcedille   ~~
    macro-to-key mtrema     "#"
    macro-to-key mligat-oe  "e"
    macro-to-key mligat-OE  "E"
    macro-to-key mdbl-ponct "!"
    macro-to-key mdbl-ponct "?"
    macro-to-key mdbl-ponct ":"
    macro-to-key mdbl-ponct ";"
    macro-to-key moguill    "<"
    macro-to-key mfguill    ">"
    macro-to-key en-tete      ^X^A
    macro-to-key man-buffer   ^XT
    macro-to-key man-print    ^XL
    macro-to-key man-queue    ^XQ
    set %fman-mode on
set $cmode &bor &bor $cmode 1 8
;    add-mode "WRAP"
;    add-mode "EXACT"
    set $discmd TRUE
    write-message "[fman mode ON]"
!endm

; --------------------------- desactivation mode man
store-procedure unset-fman-mode
    set $discmd FALSE
    unbind-key "`"
    unbind-key "'"
    unbind-key "^"
    unbind-key ~~
    unbind-key "#"
    unbind-key "e"
    unbind-key "E"
    unbind-key "!"
    unbind-key "?"
    unbind-key ":"
    unbind-key ";"
    unbind-key "<"
    unbind-key ">"
    unbind-key ^X^A
    unbind-key ^XT
    unbind-key ^XL
    unbind-key ^XQ
    set %fman-mode off
    set $cmode &band $cmode &bnot 9
;    delete-mode "WRAP"
;    delete-mode "EXACT"
    set $discmd TRUE
    write-message "[fman mode OFF]"
!endm

store-procedure n-window
    next-window
    winhook
!endm

store-procedure p-window
    previous-window
    winhook
!endm

store-procedure d-window
    delete-window
    winhook
!endm

store-procedure winhook
    !if &sequal $bufhook ""
	!return
    !endif
    !force execute-named-command $bufhook	; bufhook='set-default-mode'
    !return
!endm

macro-to-key n-window ^XO
macro-to-key p-window ^XP
macro-to-key d-window ^X0
macro-to-key set-fman-mode M-T
macro-to-key unset-fman-mode M-^T

set %search-fw ""

write-message "[fman mode ON]"
set $discmd TRUE

