;  ftex.cmd:	Procedures pour saisie de texte francais en TeX et LaTeX 
;		traitement des lettres accentuees, du c cedille, des
;		ligatures oe et OE et de l'espace force avant : ; ! ?
;		ainsi que les begin/end des environnements LaTeX et les {} ,
;		le "TeXage" du tampon courant ainsi que l'impression du dvi
;		resultant.
;		Version Unix
;		Auteur : Eric Picheral au CICB <picheral@cicb.cicb.fr>
;		20 octobre 1989
; Ne fonctionne qu'avec MicroEMACS 3.12
;
; Modifications :
; B.Decouty, 07/11/89: ajout "y" comme reponse positive, en plus de "o"
; B.Decouty, 13/11/89: ajout \fguill (>>) et \oguill (<<)
; E.Picheral 01/12/89: ajout delete-other-windows dans tex-buffer
; E.Picheral 11/12/89: unmark-buffer au lieu d'acrobatie ds tex-buffer
; E.Picheral 12/12/89: ajout set-ftex-mode et unset-ftex-mode
;		       modif cles ^X-O ^X0 et ^X-P => executer $bufhook
; E.Picheral 29/01/89: ajout \begin{document}...\end{document} ds ^X^A,
;		       messages, correction position curseur ligne erronee,
;		       execution $bufhook au lieu de macro-21
;		       ajout tex-err-fwd et tex-err-rev (^X^J)
; E.Picheral 13/02/90: ajout d'un save-file au debut de la macro tex-buffer
;		       ajout set/unset-mmode M-( / M-) et set/unset-cmmode
;		       M-[ / M-]
; E.Picheral 22/02/90: correction bogues ds latex-cenv => ca fonctionne
;		       correction controle "mode maths"
; E.Picheral 05/04/90: unset-french/set-french si entree/sortie verbatim
;		       corrections $discmd, nvlles cles :
;		       set/unset-french (M-+ / M--)
;		       set/unset-ftex-mode (M-T / M-^T)
;		       corrections mineures tex-buffer
; B.Decouty  23/02/90: remove-mark => eviter ^W intempestif
; E.Picheral 09/04/90: << et >> {} apres o/fguill au lieu d'espace
; E.Picheral 10/02/91: add-mode et delete-mode foutent la zone sur SPARC,
;		       on remplace donc par des set $cmode .. (a completer)
;		       Mais il faudrait voir ca de pres, car la version
;		       IRISA fonctionne bien ! 
; E.Picheral 15/02/91: message => OE en majuscules, unbind-key ^XQ
; E.Picheral 26/06/92: generation car 8-bits depuis <voyelle><accent>
;		       et macros depuis car 8-bits selon valeur %huit-bit
; E.Picheral 26/07/92: espace avant dbl ponct au lieu de ~
; E.Picheral 29/09/92: ajout macro latex-end-env liee a M-^D
;		       ajouts set $discmd ...
; E.Picheral 02/12/92: << => "<< ", >> => " >>"
; E.Picheral 08/07/93: amelioration codage ligatures oe et OE
; E.Picheral 13/08/93: ESC-[ et ESC-] => ESC-^[ et ESC-^] sinon anomalie
;		       avec touches Fonctions
; E.Picheral 22/08/94: on active de toutes facons set-french et unset-french
;		       on genere \item si itemize et \item[] si description
; E.Picheral 10/11/94: ajout macro  latex-classe => LaTeX2e, traitement letter,
;		       tabular
; E.Picheral 26/01/95: separation traitement double-ponctuation et accents
; E.Picheral 12/04/95: correction macro latex-classe (boucle en m-emacs 4.0)
; E.Picheral 18/12/96: valeurs par defaut pour \begin \end environnement
;		       et \documentclass

set $discmd FALSE
set %groupold "itemize"

; --------- generation de car. 8 bits par e' ...
store-procedure geniso
    set %huit-bit on
!endm

; --------- generation de \'{e} ... par e' ...
store-procedure genascii
    set %huit-bit off
!endm

; --------- remplacer  par \'{e}...
store-procedure isotoasc
set $discmd FALSE
    set-mark
    replace-string "" "\`{a}"
    goto-mark
    replace-string "" "\^{a}"
    goto-mark
    replace-string "" "\'{e}"
    goto-mark
    replace-string "" "\`{e}"
    goto-mark
    replace-string "" "\^{e}"
    goto-mark
    replace-string "" "\~"{e}"
    goto-mark
    replace-string "" "\^{\i}"
    goto-mark
    replace-string "" "\^{o}"
    goto-mark
    replace-string "" "\`{u}"
    goto-mark
    replace-string "" "\^{u}"
    goto-mark
    replace-string "" "\~"{\i}"
    goto-mark
    replace-string "" "\~"{u}"
    goto-mark
    replace-string "" "\c{c}"
    goto-mark
    replace-string "" "\`{A}"
    goto-mark
    replace-string "" "\^{A}"
    goto-mark
    replace-string "" "\'{E}"
    goto-mark
    replace-string "" "\`{E}"
    goto-mark
    replace-string "" "\^{E}"
    goto-mark
    replace-string "" "\~"{E}"
    goto-mark
    replace-string "" "\^{I}"
    goto-mark
    replace-string "" "\^{O}"
    goto-mark
    replace-string "" "\`{U}"
    goto-mark
    replace-string "" "\^{U}"
    goto-mark
    replace-string "" "\~"{I}"
    goto-mark
    replace-string "" "\~"{U}"
    goto-mark
    replace-string "" "\C{c}"
    goto-mark
    replace-string "" "<<"
    goto-mark
    replace-string "" ">>"
    goto-mark
set $discmd TRUE
!endm

; --------- remplacer \'{e} par  ...
store-procedure asctoiso
set $discmd FALSE
    set-mark
    replace-string "\`{a}" ""
    goto-mark
    replace-string "\^{a}" ""
    goto-mark
    replace-string "\'{e}" ""
    goto-mark
    replace-string "\`{e}" ""
    goto-mark
    replace-string "\^{e}" ""
    goto-mark
    replace-string "\~"{e}" ""
    goto-mark
    replace-string "\^{\i}" ""
    goto-mark
    replace-string "\^{o}" ""
    goto-mark
    replace-string "\`{u}" ""
    goto-mark
    replace-string "\^{u}" ""
    goto-mark
    replace-string "\~"{\i}" ""
    goto-mark
    replace-string "\~"{u}" ""
    goto-mark
    replace-string "\c{c}" ""
    goto-mark
    replace-string "\`{A}" ""
    goto-mark
    replace-string "\^{A}" ""
    goto-mark
    replace-string "\'{E}" ""
    goto-mark
    replace-string "\`{E}" ""
    goto-mark
    replace-string "\^{E}" ""
    goto-mark
    replace-string "\~"{E}" ""
    goto-mark
    replace-string "\^{I}" ""
    goto-mark
    replace-string "\^{O}" ""
    goto-mark
    replace-string "\`{U}" ""
    goto-mark
    replace-string "\^{U}" ""
    goto-mark
    replace-string "\~"{I}" ""
    goto-mark
    replace-string "\~"{U}" ""
    goto-mark
    replace-string "\C{c}" ""
    goto-mark
    replace-string "<<" ""
    goto-mark
    replace-string ">>" ""
    goto-mark
set $discmd TRUE
!endm

; ---------  -----------
store-procedure agrave
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\`{a}"
    !endif
!endm

; ---------  -----------
store-procedure acirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{a}"
    !endif
!endm

; ---------  -----------
store-procedure eaigu
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\'{e}"
    !endif
!endm

; ---------  -----------
store-procedure egrave
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\`{e}"
    !endif
!endm

; ---------  -----------
store-procedure ecirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{e}"
    !endif
!endm

; ---------  -----------
store-procedure etrema
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\~"{e}"
    !endif
!endm

; ---------  -----------
store-procedure icirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{i}"
    !endif
!endm

; ---------  -----------
store-procedure itrema
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\~"{i}"
    !endif
!endm

; ---------  -----------
store-procedure ocirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{o}"
    !endif
!endm

; ---------  -----------
store-procedure ugrave
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\`{u}"
    !endif
!endm

; ---------  -----------
store-procedure ucirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{u}"
    !endif
!endm

; ---------  -----------
store-procedure utrema
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\~"{u}"
    !endif
!endm

; ---------  -----------
store-procedure ccedille
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\c{c}"
    !endif
!endm

; ---------  -----------
store-procedure Agrave
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\`{A}"
    !endif
!endm

; ---------  -----------
store-procedure Acirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{A}"
    !endif
!endm

; ---------  -----------
store-procedure Eaigu
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\'{E}"
    !endif
!endm

; ---------  -----------
store-procedure Egrave
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\`{E}"
    !endif
!endm

; ---------  -----------
store-procedure Ecirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{E}"
    !endif
!endm

; ---------  -----------
store-procedure Etrema
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\~"{E}"
    !endif
!endm

; ---------  -----------
store-procedure Icirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{I}"
    !endif
!endm

; ---------  -----------
store-procedure Itrema
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\~"{I}"
    !endif
!endm

; ---------  -----------
store-procedure Ocirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{O}"
    !endif
!endm

; ---------  -----------
store-procedure Ugrave
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\`{U}"
    !endif
!endm

; ---------  -----------
store-procedure Ucirc
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\^{U}"
    !endif
!endm

; ---------  -----------
store-procedure Utrema
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\~"{U}"
    !endif
!endm

; ---------  -----------
store-procedure Ccedille
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "\c{C}"
    !endif
!endm

; ---------  -----------
store-procedure guillg
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string "<<"
    !endif
!endm

; ---------  -----------
store-procedure guilld
    !if &sequal %huit-bit on
	insert-string ""
    !else
        insert-string ">>"
    !endif
!endm

; ------------------ {eE} apostrophe
store-procedure aigu
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "'"
	!return
    !endif
    backward-character
    !if &or &sequal &chr $curchar e &sequal &chr $curchar E
	!if &sequal %huit-bit on
	    !if &sequal &chr $curchar E
		insert-string ""
	    !else
		insert-string ""
	    !endif
	!else
	    insert-string &cat &cat "\'{" &chr $curchar "}"
	!endif
	delete-next-character
    !else
	forward-character
	insert-string "'"
    !endif
!endm

; ------------------ {aeuAEU} accent grave
store-procedure grave
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "`"
	!return
    !endif
    backward-character
    set %numvoy &sindex "aeuAEU" &chr $curchar
    !if &greater %numvoy 0
        !if &sequal %huit-bit on
	    insert-string &mid "" %numvoy 1
	!else
	    insert-string &cat &cat "\`{" &chr $curchar "}"
	!endif
	delete-next-character
    !else
	forward-character
	insert-string "`"
    !endif
!endm

; ------------------ {aeiouAEIOU} chapeau
store-procedure circ
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "^"
	!return
    !endif
    backward-character
    set %numvoy &sindex "aeouAEIOU" &chr $curchar
    !if &greater %numvoy 0
        !if &sequal %huit-bit on
            insert-string &mid "" %numvoy 1
        !else
	    insert-string &cat &cat "\^{" &chr $curchar "}"
	!endif
	delete-next-character
    !else
	!if &sequal &chr $curchar i
            !if &sequal %huit-bit on
        	insert-string ""
	    !else
	        insert-string "\^{\i}"
	    !endif
	    delete-next-character
	!else
	    forward-character
	    insert-string "^"
	!endif
    !endif
!endm

; ------------------ {cC} tilda
store-procedure cedille
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "~~"
	!return
    !endif
    backward-character
    !if &or &sequal &chr $curchar c &sequal &chr $curchar C
        !if &sequal %huit-bit on
	    !if &sequal &chr $curchar C
                insert-string ""
            !else
                insert-string ""
            !endif
        !else
	    insert-string &cat &cat "\c{" &chr $curchar "}"
        !endif
	delete-next-character
    !else
	forward-character
	insert-string "~~"
    !endif
!endm

; ------------------ {eiuEIU} dieze
store-procedure trema
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "#"
	!return
    !endif
    backward-character
    set %numvoy &sindex "euEIU" &chr $curchar
    !if &greater %numvoy 0
        !if &sequal %huit-bit on
            insert-string &mid "" %numvoy 1
        !else
            insert-string &cat &cat "\~"{" &chr $curchar "}"
        !endif
        delete-next-character
    !else
        !if &sequal &chr $curchar i
            !if &sequal %huit-bit on
                insert-string ""
            !else
                insert-string "\~"{\i}"
            !endif
	    delete-next-character
	!else
	    forward-character
	    insert-string "#"
	!endif
    !endif
!endm

; ---------------------- ligature optionnelle oe
store-procedure ligat-oe
    !if &and &equal $curcol 0 &equal $curline 1
	!force insert-string &chr $lastkey
	!return
    !endif
    backward-character
    !if &sequal &chr $curchar o
	print ""
	write-message "ligature oe ? (o/n, [o])"
	set %fligat &gtk
	!if &or &sequal %fligat "o" &or &sequal %fligat "y" &sequal %fligat "~r"
	    insert-string "\oe{}"
	    delete-next-character
	!else
	    forward-character
	    insert-string "e"
	!endif
    !else
	forward-character
	insert-string "e"
    !endif
!endm

; ---------------------- ligature optionnelle OE
store-procedure ligat-OE
    !if &and &equal $curcol 0 &equal $curline 1
	!force insert-string &chr $lastkey
	!return
    !endif
    backward-character
    !if &sequal &chr $curchar O
	print ""
	write-message "ligature OE ? (o/n, [o])"
	set %fligat &gtk
	!if &or &sequal %fligat "o"  &or &sequal %fligat "y" &sequal %fligat "~r"
	    insert-string "\OE{}"
	    delete-next-character
	!else
	    forward-character
	    insert-string "E"
	!endif
    !else
	forward-character
	insert-string "E"
    !endif
!endm

; ----------------------- insertion espace avant : ; ! ?
store-procedure dbl-ponct
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string &chr $lastkey
	!return
    !endif
    backward-character
    !while &or &equal $curchar 32 &sequal &chr $curchar " t"
	delete-next-character
	backward-character
    !endwhile
    !if &not &sequal &chr $curchar " "
	forward-character
	insert-string " "
    !else
	forward-character
    !endif
    insert-string &chr $lastkey
!endm

; ------------------------ creation bloc {}
store-procedure tex-braces
	insert-string "{}"
	backward-character
!endm

; ------------------------ sortie bloc courant
store-procedure tex-cbrace
    set $discmd FALSE
    set %pile 1
    set-mark
    end-of-file
    set %ff $curline
    goto-mark
    !while &greater %pile 0
	!if &equal $curchar &ascii "{"
	    backward-character
	    !if &not &equal $curchar &ascii "\"
		set %pile &add %pile 1
	    !endif
	    forward-character
	!endif
	!if &equal $curchar &ascii "}"
	    backward-character
	    !if &not &equal $curchar &ascii "\"
		set %pile &sub %pile 1
	    !endif
	    forward-character
	!endif
	!if &equal %ff $curline
	    print "accolade } manquante"
	    goto-mark
	    remove-mark
	    set $discmd TRUE
	    !return
	!endif
	forward-character
    !endwhile
    remove-mark
    set $discmd TRUE
!endm

; ----------------------- creation \( \) maths en ligne
store-procedure set-mmode
    insert-string "\(\)"
    2 backward-character
    unset-french
!endm

; ----------------------- creation \[ \] maths hors texte
store-procedure set-cmmode
    insert-string "\[~n~n\]~n"
    4 backward-character
    unset-french
!endm

; ------------------------- sortie bloc maths en ligne
store-procedure unset-mmode
    set %svsearch $search
    !force search-forward "\)"
    !if &not $status
	!if &sequal $version 3.11c8
	    write-message "[mode math non ferm]"
	!else
	    write-message "[mode math non ferme]"
	!endif
    !endif
    set-french
    set $search %svsearch
!endm

; ------------------------- sortie bloc maths hors-texte
store-procedure unset-cmmode
    set %svsearch $search
    !force search-forward "\]"
    !if &not $status
	!if &sequal $version 3.11c8
	    write-message "[mode math hors-texte non ferm]"
	!else
	    write-message "[mode math hors-texte non ferme]"
	!endif
    !endif
    set-french
    set $search %svsearch
!endm

; ------------------------- \documentstyle \begin{document} \end{document}
store-procedure latex-style
	open-line
	beginning-of-file
	set %style @"style de document ?"
	set %options @"options ?"
	!if &greater &length %options 0
	    set %options1 &cat &cat "[" %options "]"
	!else
	    set %options1 ""
	!endif
	insert-string &cat &cat &cat &cat "\documentstyle" %options1 "{" %style "}~n~n"
	insert-string "\begin{document}~n"
	set $discmd FALSE
	9 set-mark
	end-of-file
	insert-string "\end{document}"
	9 goto-mark
	set $discmd TRUE
!endm

; --------- TAB -----------
store-procedure tab
	!if &seq %etat letter
	    set $discmd FALSE 
	    !force search-forward "{}"
	    !if &not $status
		previous-line
		beginning-of-line
		set %etat repos
		set $discmd TRUE
	    !else
		backward-character
	    !endif
	!else
	!if &seq %etat descr
	    insert-string "~n\item[]"
	    backward-character
	!else
	!if &seq %etat itemnum
	    insert-string "~n\item "
	!else
	    insert-string "~t"
	!endif
!endm
    
; ------------------------- \documentclass \begin{document} \end{document}
store-procedure latex-classe
	open-line
	beginning-of-file
	set %classe @&cat "classe de document " "[article] ?"
	!if &seq %classe ""
	    set %classe "article"
	!endif
	set %options @"options de classe ?"
	!if &greater &length %options 0
	    set %options1 &cat &cat "[" %options "]"
	!else
	    set %options1 ""
	!endif
	insert-string &cat &cat &cat &cat "\documentclass" %options1 "{" %classe "}~n~n"

	set %extension @"extensions ?"
	!while &greater &length %extension 0
                set %options @"options d'extension ?"
                !if &greater &length %options 0
                    set %options1 &cat &cat "[" %options "]"
                !else
                    set %options1 ""
                !endif
                insert-string &cat &cat &cat &cat "\usepackage" %options1 "{" %extension "}~n"
            !endif
	    set %extension @"extensions ?"
	!endwhile
	insert-string "~n\begin{document}~n"
	set $discmd FALSE
	9 set-mark
	end-of-file
	insert-string "\end{document}"
	9 goto-mark
	!if &or &seq %classe crilet &seq %classe letter
	    insert-string &cat &cat "~n\begin{" letter "}~n~n\opening{}~n~n~n\closing{}~n\end{"
	    insert-string &cat letter "}~n"
	    set $search "\usepackage"
	    !force search-reverse
	    !if &not $status
		 !force search-reverse "\documentclass"
	    !endif
	    next-line
	    insert-string "\signature{}"
	    backward-character
	    set %etat letter
	!endif
	set $discmd TRUE
!endm

; ----------------------- creation environnement \begin ... \end
store-procedure latex-env
	set %group @&cat &cat &cat "environnement " "[" %groupold "] ?"
	!if &seq %group ""
	    set %group %groupold
	!endif
	set %groupold %group
	insert-string &cat &cat "~n\begin{" %group "}~n~n\end{"
	insert-string &cat %group "}~n"
	!if &seq %group verbatim
	    unset-french
	!endif
	2 previous-line
	!if &or &seq %group itemize &seq %group enumerate
	    insert-string "\item "
	    set %etat itemnum
	!endif
	!if &seq %group description
	    insert-string "\item[]"
	    backward-character
	    set %etat descr
	!endif
	!if &seq %group letter
	    insert-string "\opening{}~n~n~n\closing{}"
	    2 previous-line
	    2 backward-character
            set %etat letter 
	!endif
	!if &seq %group tabular
	    backward-character
	    insert-string "{}"
	    backward-character
	!endif
!endm

; ------------------------ sortie environnement courant
store-procedure latex-cenv
	set %etat repos
        set $discmd FALSE  
	set %svsearch $search
	set %error FALSE
	0 set-mark
	end-of-file
	set %dlig $curline
	set %dcol $curcol
	0 goto-mark
	set %svmode $cmode
	add-mode "magic"
	!while &not %error
	    test-begin-end
	    !if &sequal %marque begin
	        saut-end-env
	    !else
	        !if &sequal %marque end
		    set $cmode %svmode
		    !if &seq %group verbatim
		        set-french
		    !endif
		    set $search %svsearch
	            set $discmd TRUE
	            !return
		!endif
	    !endif
	!endwhile
        print "\end{...} manquant"
	0 goto-mark
	0 remove-mark
	set $cmode %svmode
	set $search %svsearch
        set $discmd TRUE
!endm

store-procedure saut-end-env
	set %pile 1
	!while &greater %pile 0
	    test-env
	    !if %error
	        !return
	    !endif
	    !if &sequal %ee begin
	        set %pile &add %pile 1
	    !else
	        !if &sequal %ee end
		    set %pile &sub %pile 1
		!else
		    set %error TRUE
		    !return
		!endif
	    !endif
	!endwhile
!endm

store-procedure test-env
    set %ligb %dlig
    set %colb %dcol
    2 set-mark
    !force search-forward &cat &cat "\\begin *{" %env "}"
    !if $status
        1 set-mark
        set %ligb $curline
	set %colb $curcol
	2 goto-mark
    !endif
    !force search-forward &cat &cat "\\end *{" %env "}"
    !if $status
	!if &greater $curline %ligb
	    set %ee begin
	    1 goto-mark
	!else
	    !if &sequal $curline %ligb
	        !if &greater $curcol %colb
		    set %ee begin
		    1 goto-mark
		!else
		    set %ee end
		!endif
	    !else
	        set %ee end
	    !endif
	!endif
    !else
	set %error TRUE
	set %ee ""
	!return
    !endif
!endm

store-procedure test-begin-end
    set %ligb %dlig
    set %colb %dcol
    2 set-mark
    !force search-forward "\\begin *{[^{]*}"
    !if $status
        1 set-mark
	set %ligb $curline
	set %colb $curcol
	set %env $match
	set %finenv &length %env
	set %debenv &add &sindex %env "{" 1
	set %env &mid %env %debenv &sub %finenv %debenv
	2 goto-mark
    !endif
    !force search-forward "\\end *{[^{]*}"
    !if $status
	!if &greater $curline %ligb
	    set %marque begin
	    1 goto-mark
	!else
	    !if &equal $curline %ligb
	        !if &greater $curcol %colb
		    set %marque begin
		    1 goto-mark
		!else
		    set %marque end
		!endif
	    !else
	        set %marque end
	    !endif
	!endif
    !else
	set %marque ""
	set %error TRUE	    
    !endif
!endm

;------------------
store-procedure latex-end-env
        9 set-mark
        search-reverse "\begin{"
        2 next-word
        delete-next-word
        yank
        9 exchange-point-and-mark
        insert-string "~n\end{"
        yank
        insert-string "}~n"
        2 previous-line
        write-message "Fait"
!endm

; ------------------------ execution TeX/LaTeX sur buffer courant
store-procedure tex-buffer
    save-file
    1 set-mark
    set %svsearch $search
    beginning-of-file
    0 set-mark
    set %svmode $cmode
    add-mode "magic"
    !force search-forward "[^ ^~t^~r]"
    set $cmode %svmode
    !force backward-character
    kill-region
    set $line &trim $line
    !if &equal &sindex $line "\documentstyle" 1
	set %commande " latex "
    !else
	!if &equal &sindex $line "\documentclass" 1
	    set %commande " latex2e "
	!else
	    set %commande " tex "
	!endif
    !endif
    open-line
    insert-string "\batchmode"
    set %unique &cat &cat "/tmp/" &env "USER" &rnd 99999
    set %unitex &cat %unique ".tex"
    set %logtex &cat &cat %unique ".log"
    set %fsauve $cfname
    write-file %unitex
    beginning-of-file
    kill-to-end-of-line
    kill-to-end-of-line
    1 goto-mark
    set %ligerr $curline
    unmark-buffer
    set $cfname %fsauve
    shell-command &cat "/bin/rm -f " &cat "/tmp/" &cat &env USER "*.dvi"
    shell-command &cat &cat &cat "cd /tmp ~; " %commande %unitex
    delete-other-windows
    split-current-window
; acrobatie a cause de l'absence de $windowhook ...
    set $readhook nop
    view-file %logtex
    set $readhook set-default-mode
;    name-buffer "commande"
; car la ligne prcdte coince au bout de trois executions ds la session !
    set $cbufname "commande"
    add-mode "exact"
    add-mode "magic"
    !force search-forward "^l\.[0-9][0-9]* "
    !if $status
	set %ligerr &mid $match 3 &sub &length $match 3
	set %ligerr &sub %ligerr 1
	!if &sequal $version 3.11c8
	    write-message "[Erreur(s) dtecte(s)]"
	!else
	    write-message "[Erreur(s) detectee(s)]"
	!endif
    !else
	write-message "[Pas d'erreur]"
    !endif
    delete-mode "magic"
    previous-window
    %ligerr goto-line
    remove-mark
    set %rmf &cat "/bin/rm -f " &cat %logtex " "
    set %rmf &cat %rmf &cat %unitex " "
;    set %rmf &cat %rmf &cat %unique ".aux"
    shell-command %rmf
    set $search %svsearch
!endm

; ------------------------- positionnement erreur suivante
store-procedure tex-err-fwd
	set %search-fw TRUE
	tex-error
!endm

; ------------------------- positionnement erreur precedente
store-procedure tex-err-rev
	set %search-fw FALSE
	tex-error
!endm

store-procedure tex-error
    !if &not &sequal $cbufname "commande"
	set %ligerr $curline
	previous-window
	!if &not &sequal $cbufname "commande"
	    write-message "[Executez d'abord tex ou latex ! (^XT)]"
	    !return
	!endif
    !endif
    set %svsearch $search
    add-mode "magic"
    !if &sequal %search-fw ""
	set %search-fw TRUE
    !endif
    !if %search-fw
	end-of-line
	!force search-forward "^l\.[0-9][0-9]* "
	!if $status
	    set %ligerr &mid $match 3 &sub &length $match 3
	    set %ligerr &sub %ligerr 1
	!else
	    write-message "[Plus d'erreur]"
	!endif
    !else
	beginning-of-line
	!force search-reverse "^l\.[0-9][0-9]* "
	!if $status
; $match contient le debut du mot suivant alors qu'on est en debut de ligne
; bug ???
	    next-word
	    set $kill ""
	    delete-mode view
	    delete-next-word
	    yank
	    add-mode view
	    beginning-of-line
	    unmark-buffer
	    set %ligerr $kill
            set %ligerr &sub %ligerr 1 ; on a rajoute une ligne
	!else
	    write-message "[Plus d'erreur]"
	!endif
    !endif
    delete-mode "magic"
    previous-window
    %ligerr goto-line
    set %search-fw ""
    set $search %svsearch
!endm

; ----------------------- activation pilote PS et impression
store-procedure tex-print
    shell-command &cat &cat "dvips " %unique ".dvi | lpr"
!endm

; ----------------------- affichage file d'attente imprimante
store-procedure tex-queue
; acrobatie a cause de l'absence de $windowhook ...
    set $readhook nop
    pipe-command "lpq"
    set $readhook set-default-mode
    add-mode "view"
    name-buffer "file d'attente"
    end-of-file
    !if &less $curline $wline
	&sub $curline 1 resize-window
    !endif
    beginning-of-file
!endm

; -------------------- << guillemets francais ouvrants
store-procedure oguill
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string "<"
	!return
    !endif
    backward-character
    !if &sequal &chr $curchar <
	insert-string "<< "
	delete-next-character
    !else
	forward-character
	insert-string "<"
    !endif
!endm

; -------------------- >> guillemets francais fermants
store-procedure fguill
    !if &and &equal $curcol 0 &equal $curline 1
	insert-string ">"
	!return
    !endif
    backward-character
    !if  &sequal &chr $curchar >
	insert-string " >>"
	delete-next-character
    !else
	forward-character
	insert-string ">"
    !endif
!endm

; --------------------------- activation mode TeX
store-procedure set-ftex-mode
    set-french
    set-dbponct
    set $discmd FALSE
;    unbind-key M-[
;    unbind-key M-]
    macro-to-key tab	      "~t"
    macro-to-key tex-braces   M-{
    macro-to-key tex-cbrace   M-}
    macro-to-key set-mmode    M-(
    macro-to-key unset-mmode  M-)
    macro-to-key set-cmmode   M-^[
    macro-to-key unset-cmmode M-^]
;    macro-to-key latex-style  ^X^A
    macro-to-key latex-classe ^X^A
    macro-to-key latex-env    ^X^G
    macro-to-key latex-cenv   ^X^H
    macro-to-key latex-end-env M-^D
    macro-to-key tex-buffer   ^XT
    macro-to-key tex-err-fwd  ^X^K
    macro-to-key tex-err-rev  ^X^J
    macro-to-key tex-print    ^XL
    macro-to-key tex-queue    ^XQ
    macro-to-key set-french   ^X+
    macro-to-key unset-french ^X-
    macro-to-key genascii     ^X7
    macro-to-key geniso       ^X8
    macro-to-key isotoasc     M-^A
    macro-to-key asctoiso     M-^I
    set %ftex-mode on
set $cmode &bor &bor $cmode 1 8
;    add-mode "WRAP"
;    add-mode "EXACT"
    set $discmd TRUE
    write-message "[mode ftex ON]"
!endm

; --------------------------- desactivation mode TeX
store-procedure unset-ftex-mode
    !if &sequal %french ON
	unset-french
    !endif
    !if &sequal %dbponct ON
	unset-dbponct
    !endif
    set $discmd FALSE
    unbind-key "~t"
    unbind-key M-{
    unbind-key M-}
    unbind-key M-(
    unbind-key M-)
    unbind-key M-^[
    unbind-key M-^]
    unbind-key ^X^A
    unbind-key ^X^G
    unbind-key ^X^H
    unbind-key M-^D
    unbind-key ^XT
    unbind-key ^X^K
    unbind-key ^X^J
    unbind-key ^XL
    unbind-key ^XQ
    unbind-key ^X+
    unbind-key ^X-
    unbind-key ^X7
    unbind-key ^X8
    unbind-key M-^A
    unbind-key M-^I
;    bind-to-key previous-paragraph M-[
;    bind-to-key next-paragraph M-]
    set %ftex-mode off
    set $cmode &band $cmode &bnot 9
;    delete-mode "WRAP"
;    delete-mode "EXACT"
    set $discmd TRUE
    write-message "[mode ftex OFF]"
!endm

; --------------------- activation dble ponct
store-procedure set-dbponct
    set $discmd FALSE
    macro-to-key dbl-ponct "!"
    macro-to-key dbl-ponct "?"
    macro-to-key dbl-ponct ":"
    macro-to-key dbl-ponct ";"
    set %dbponct ON
    write-message "[double ponctuation ON]"
    set $discmd TRUE
!endm

; --------------------- desactivation dble ponct
store-procedure unset-dbponct
    set $discmd FALSE
    unbind-key "!"
    unbind-key "?"
    unbind-key ":"
    unbind-key ";"
    set %dbponct OFF
    write-message "[double poctuation OFF]"
    set $discmd TRUE
!endm

; --------------------- activation lettres accentuees, ligat
store-procedure set-french
    set $discmd FALSE
    macro-to-key agrave    ""
    macro-to-key acirc     ""
    macro-to-key eaigu     ""
    macro-to-key egrave    ""
    macro-to-key ecirc     ""
    macro-to-key etrema    ""
    macro-to-key icirc     ""
    macro-to-key itrema    ""
    macro-to-key ocirc     ""
    macro-to-key ugrave    ""
    macro-to-key ucirc     ""
    macro-to-key utrema    ""
    macro-to-key ccedille  ""
    macro-to-key Agrave    ""
    macro-to-key Acirc     ""
    macro-to-key Eaigu     ""
    macro-to-key Egrave    ""
    macro-to-key Ecirc     ""
    macro-to-key Etrema    ""
    macro-to-key Icirc     ""
    macro-to-key Itrema    ""
    macro-to-key Ocirc     ""
    macro-to-key Ugrave    ""
    macro-to-key Ucirc     ""
    macro-to-key Utrema    ""
    macro-to-key Ccedille  ""
    macro-to-key guillg    ""
    macro-to-key guilld    ""
    macro-to-key aigu      "'"
    macro-to-key grave     "`"
    macro-to-key circ      "^"
    macro-to-key cedille   ~~
    macro-to-key trema     "#"
    macro-to-key ligat-oe  "e"
    macro-to-key ligat-OE  "E"
    macro-to-key oguill    "<"
    macro-to-key fguill    ">"
    set %french ON
    write-message "[accents ON]"
    set $discmd TRUE
!endm

; --------------------- desactivation lettres accentuees, ligat
store-procedure unset-french
    set $discmd FALSE
    unbind-key ""
    unbind-key "`"
    unbind-key "'"
    unbind-key "^"
    unbind-key ~~
    unbind-key "#"
    unbind-key "e"
    unbind-key "E"
    unbind-key "<"
    unbind-key ">"
    set %french OFF
    write-message "[accents OFF]"
    set $discmd TRUE
!endm

store-procedure n-window
    next-window
    winhook
!endm

store-procedure p-window
    previous-window
    winhook
!endm

store-procedure d-window
    delete-window
    winhook
!endm

store-procedure winhook
    !if &sequal $bufhook ""
	!return
    !endif
    set $bufhook buffer-default-mode
    !return
!endm

macro-to-key n-window ^XO
macro-to-key p-window ^XP
macro-to-key d-window ^X0
macro-to-key set-ftex-mode M-T
macro-to-key unset-ftex-mode M-^T
macro-to-key set-french ^X+
macro-to-key unset-french ^X-
;macro-to-key set-dbponct ...
;macro-to-key unset-dbponct ...

set %search-fw ""
set %french ON
set %dbponct ON

write-message "[fTeX mode ON]"
set $discmd TRUE
